<?php

/**
 * Simpla CMS
 */

require_once 'Simpla.php';

class bifitactions extends Simpla
{
	public function get_tranzactions()
	{
		$tranzactions = array();
		$query = $this->db->placehold("SELECT *
										FROM __bifit_reports ORDER BY `id` DESC");
		$this->db->query($query);

		return $this->db->results();
	}

	public function get_tranzaction($id)
	{
		if (is_int($id)) {
			$filter = $this->db->placehold('id = ?', $id);
		} else {
			$filter = $this->db->placehold('url = ?', $id);
		}
		$query = "SELECT id, name, url, description, image, position
								 FROM __bifit_reports WHERE $filter ORDER BY position LIMIT 1";
		$this->db->query($query);

		return $this->db->result();
	}

	public function add_tranzaction($tranzaction)
	{
		$query = $this->db->placehold(
			"INSERT INTO __bifit_reports SET ?%",
			$tranzaction
		);

		$this->db->query($query);
		$id = $this->db->insert_id();
		$query = $this->db->placehold(
			"UPDATE __bifit_reports SET position=id WHERE id=? LIMIT 1",
			$id
		);

		$this->db->query($query);

		return $id;
	}

	public function update_tranzaction($id, $tranzaction)
	{
		$query = $this->db->placehold(
			"UPDATE __bifit_reports SET ?% WHERE id in(?@) LIMIT ?",
			(array) $tranzaction,
			(array) $id,
			count((array) $id)
		);

		$this->db->query($query);

		return $id;
	}

	public function delete_tranzaction($id)
	{
		if (!empty($id)) {
			$query = $this->db->placehold(
				"DELETE FROM __bifit_reports WHERE id=? LIMIT 1",
				$id
			);
			$this->db->query($query);
		}
	}

	public function checkDbSheme()
	{
		$this->db->query('SHOW TABLES LIKE "s_bifit_settings"');

		if (empty($this->db->result())) {
			$creaTabSql = 'CREATE TABLE IF NOT EXISTS `s_bifit_settings` (
					id int(11) NOT NULL AUTO_INCREMENT PRIMARY KEY,
					`data` text NOT NULL					
				)';
		}

		$this->db->query($creaTabSql);
		$this->db->query('SHOW TABLES LIKE "s_bifit_reports"');

		if (empty($this->db->result())) {
			$creaTabSql = 'CREATE TABLE IF NOT EXISTS `s_bifit_reports` (
					id int(11) NOT NULL AUTO_INCREMENT PRIMARY KEY,
					order_id int(11) NOT NULL,
					order_number varchar(50) NOT NULL,
					order_date datetime NOT NULL DEFAULT "0000-00-00 00:00:00",
					action_date datetime NOT NULL DEFAULT "0000-00-00 00:00:00",
					receipt_link varchar(255) NOT NULL,
					receipt_id int(11) NOT NULL,
					receipt_type varchar(50) NOT NULL,
					log text NOT NULL
				)';
		}

		$this->db->query($creaTabSql);
	}

	public function getSettings()
	{
		$sql = 'SELECT data FROM s_bifit_settings WHERE id=1';
		$query = $this->db->placehold($sql);
		$this->db->query($query);

		return json_decode($this->db->result('data'));
	}

	public function update_settings($data)
	{
		$query = $this->db->placehold(
			"UPDATE __bifit_settings SET data='" .
				$this->db->escape(trim($data)) .
				"' WHERE id=1"
		);

		$this->db->query($query);
	}

	public function add_settings($data)
	{
		$query = $this->db->placehold(
			"INSERT INTO __bifit_settings SET `data`='" .
				$this->db->escape(trim($data)) .
				"'"
		);
		$this->db->query($query);
	}

	function get_payment_method($module)
	{
		$query = $this->db->placehold(
			"SELECT * FROM __payment_methods WHERE module=? LIMIT 1",
			$module
		);
		$this->db->query($query);
		$payment_method = $this->db->result();
		return $payment_method;
	}

	function __formatprc($price)
	{
		// форматируем цену согласно настроек
		$price =
			$this->settings->price_decimals_poin < 0
				? round($price, $this->settings->price_decimals_poin)
				: number_format(
					$price,
					$this->settings->price_decimals_poin,
					'.',
					''
				);

		return $price;
	}

	function __checkInn($inn, $type = 1)
	{
		// проверяем заполненность
		if (isset($inn) && trim($inn) != '') {
			if ($type == 2) {
				// только цифры в количестве 10 шт.
				$inn = !preg_match("/^\d{10}$/", trim($inn))
					? 'ИНН задан в неверном формате!'
					: trim($inn);
			} elseif ($type == 1) {
				// только цифры в количестве 12 шт.
				$inn = !preg_match("/^\d{12}$/", trim($inn))
					? 'ИНН задан в неверном формате!'
					: trim($inn);
			} else {
				// только цифры в количестве 10 или 12 шт.
				$inn = !preg_match("/^\d{10}$|^\d{12}$/", trim($inn))
					? 'ИНН задан в неверном формате!'
					: trim($inn);
			}
		} else {
			// ИНН пуст или не найден!
			$inn = 'ИНН пуст или не найден!';
		}

		return $inn;
	}

	function __checkPhone($tel)
	{
		// проверяем заполненность
		if (isset($tel) && trim($tel) != '') {
			// удаляем лишние символы
			$phone = str_replace(
				array('+', '(', ')', '-', ' '),
				'',
				trim($tel)
			);

			// получаем первую цифру
			$first = substr($phone, "0", 1);

			// если номер из 10 цифр и первая цифра не 7, то добавляем 7
			$phone =
				strlen($phone) == 10 && $first != 7 ? '7' . $phone : $phone;

			// окончательная проверка
			$phone = !preg_match("/^[0-9]{11}+$/", $phone)
				? 'Телефон задан в неверном формате!'
				: $phone;
		} else {
			// Телефон пуст или не найден!
			$phone = 'Телефон пуст или не найден!';
		}

		return $phone;
	}

	function __checkEmail($email)
	{
		// проверка модели записи
		$email = !preg_match("/^\+\d+$|^\S+@\S+$/", $email)
			? 'E-mail задан в неверном формате!'
			: $email;

		return $email;
	}

	function __checkProductPrice(
		$item_price,
		$order_subtotal,
		$order_discount = 0,
		$order_payment = 0
	) {
		// если скидка больше нуля
		if ($order_discount > 0) {
			// вычисляем процент скидки
			$percent = ($order_discount * 100) / $order_subtotal;

			// уменьшаем цену товара согласно скидки
			$item_price = $item_price - $item_price * ($percent / 100);
		}

		// если система оплаты больше нуля
		if ($order_payment > 0) {
			// вычисляем процент наценки
			$percent =
				($order_payment * 100) / ($order_subtotal - $order_discount);

			// увеличиваем цену товара согласно наценки
			$item_price = $item_price + $item_price * ($percent / 100);
		}

		return $item_price;
	}

	function __checkResponce($response)
	{
		$mess = '';

		if (
			is_object($response) &&
			($response->type == 'ERROR' || $response->status == 400)
		) {
			$mess = '';
			if ($response->status == 400) {
				$mess .= $response->error . "\n";
				$mess .= $response->message . "\n";
			} else {
				$array = json_decode(json_encode($response), true);
				array_walk_recursive($array, function ($item, $key) use (
					&$mess
				) {
					if ($item != 'ERROR' && trim($item != '')) {
						$mess .= $key . ': ' . $item . "\n";
					}
				});
			}
		} elseif (is_object($response)) {
			$array = json_decode(json_encode($response), true);
			array_walk_recursive($array, function ($item, $key) use (&$mess) {
				if (trim($item != '')) {
					$mess .= $key . ': ' . $item . "\n";
				}
			});
		}

		return $mess;
	}

	public static function __createGUID($order)
	{
		// Create GUID (Globally Unique Identifier)
		$guid = '';
		$namespace = rand(11111, 99999);
		$uid = uniqid('', true);
		$data = $namespace;
		$data .= $_SERVER['REQUEST_TIME'];
		$data .= $_SERVER['HTTP_USER_AGENT'];
		$data .= $_SERVER['REMOTE_ADDR'];
		$data .= $_SERVER['REMOTE_PORT'];
		$data .= $order['number'];
		$data .= $order['summ'];
		$hash = strtoupper(hash('ripemd128', $uid . $guid . md5($data)));
		$guid =
			substr($hash, 0, 8) .
			'-' .
			substr($hash, 8, 4) .
			'-' .
			substr($hash, 12, 4) .
			'-' .
			substr($hash, 16, 4) .
			'-' .
			substr($hash, 20, 12);

		return strtolower($order['cms'] . '-' . $guid);
	}

	function __loadData($url, $headers = false, $data = false, $type = 'POST')
	{
		// initialize the cURL session
		$ch = curl_init($url);

		// assign request type
		if ($type != 'POST') {
			curl_setopt($ch, CURLOPT_CUSTOMREQUEST, $type);
		} else {
			curl_setopt($ch, CURLOPT_POST, true);
		}

		// add data
		if ($data) {
			curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
		}

		// returning the result as a string
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_ENCODING, '');
		curl_setopt($ch, CURLOPT_MAXREDIRS, 10);
		curl_setopt($ch, CURLOPT_TIMEOUT, 0);
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
		curl_setopt($ch, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_1);

		// add headers
		if ($headers) {
			curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
		}

		// get the answer
		$output = curl_exec($ch);

		// close the cURL session
		curl_close($ch);

		return $output;
	}

	function __saveReport(
		$test,
		$bifit,
		$receipt,
		$receipt_id,
		$doc,
		$object,
		$idemp_key
	) {
		// выводим свойство операции
		$log =
			$test != ''
				? '####### ' . 'Тестовый запрос' . "\n"
				: '####### ' . 'Боевой запрос' . "\n";

		// устанавливаем часовой пояс согласно настройкам сайта
		date_default_timezone_set('UTC');
		$log .= '####### ' . date('Y-m-d H:i:s', time()) . "\n";

		// ОТВЕТ #1

		$log .= '####### ' . 'Ответ' . ' #1: ' . "\n";

		// данные ответа #1
		$token_error = null;

		if (is_object($bifit)) {
			foreach ($bifit as $key => $val) {
				if ($key == 'error') {
					$token_error = 1;
				}
				$log .= $key . ': ' . $val . "\n";
			}
		}

		// ЧЕК

		// сформированный чек для отправки
		$log .= '####### ' . 'Чек' . ': ' . "\n" . $receipt . "\n";

		if (!$token_error) {

			// КЛЮЧ ИДЕМПОТЕНТНОСТИ

			$log .=
				'####### ' .
				'Ключ идемпотентности' .
				': ' .
				"\n" .
				$idemp_key .
				"\n";

			// ОТВЕТ #2

			$log .= '####### ' . 'Ответ' . ' #2: ' . "\n";

			// данные ответа #2
			if (is_object($receipt_id)) {
				$log .= self::__checkResponce($receipt_id);
			} else {
				$log .= 'Номер документа: ' . $receipt_id . "\n";

				// ОТВЕТ #3

				$log .= '####### ' . 'Ответ' . ' #3: ' . "\n";

				if (is_object($doc)) {
					$log .= self::__checkResponce($doc);
				}

				// ССЫЛКА НА ЧЕК

				// сформированная ссылка на чек
				$log .=
					'####### ' .
					'Ссылка на чек' .
					': ' .
					"\n" .
					$object->receipt_link;
			}
		}

		$object->log = $log;

		$this->checkDbSheme();

		// СОХРАНЯЕМ В БД
		$q =
			"INSERT IGNORE INTO `s_bifit_reports` SET 
				`order_id` 		= " .
			$object->order_id .
			", 
				`order_number`	= '" .
			$object->order_number .
			"', 
				`order_date`	= '" .
			$object->order_date .
			"', 
				`action_date`	= '" .
			$object->action_date .
			"', 
				`receipt_link`	= '" .
			$object->receipt_link .
			"', 
				`receipt_id`	= '" .
			(int) $object->receipt_id .
			"', 
				`receipt_type`	= '" .
			$object->receipt_type .
			"', 
				`log`			= '" .
			$object->log .
			"'";
		$query = $this->db->placehold($q);

		$this->db->query($query);
	}

	function __mainProcess($settings, $order, $test, $token, $i)
	{
		// 1. АВТОРИЗАЦИЯ
		//    процесс необходимый для подключения клиента к фискальному процессингу

		// адрес для POST-запроса
		$url = 'https://fp' . $test . '.bifit.com/processing-api/oauth/token';

		// данные ссылки
		$data = 'token=' . $token;
		$data .= '&client_id=processing-connector-token';
		$data .= '&client_secret=processing-connector-token';
		$data .= '&grant_type=token';

		// headers
		$headers = array('Content-Type: application/x-www-form-urlencoded');

		// декодируем полученный json-ответ
		$bifit = json_decode(self::__loadData($url, $headers, $data));

		// 2. ФОРМИРОВАНИЕ КОНТЕНТА ЧЕКА
		//    формирование информации для дальнейшей отправки на фискализацию

		// параметры плагина
		/// имя кассира
		$cashier_name = $settings['bifitkassa_cashier_name'];
		/// ИНН кассира
		$cashier_inn = $settings['bifitkassa_cashier_inn'];
		/// тип документа
		$arr_rec_type = array(
			'1' => 'SALE',
			'2' => 'SALE_RETURN',
			'3' => 'PURCHASE',
			'4' => 'PURCHASE_RETURN'
		);
		$receipt_type = $arr_rec_type[$i];
		/// система налогов
		$tax_system = $settings['bifitkassa_tax_system_' . $i];
		/// признак способа расчёта
		$calc_method = $settings['bifitkassa_calculation_method'];
		/// единый НДС
		$vat_mode = $settings['bifitkassa_vat_mode'];
		/// НДС
		$vat = $settings['bifitkassa_vat'];
		/// тип оплаты
		$payment_type = $settings['bifitkassa_payment_type'];
		/// место расчётов
		$payment_address = $settings['bifitkassa_payment_address'];
		/// тип адреса клиента
		$address_type = $settings['bifitkassa_address_type'];
		/// ФИО клиента
		$fio = $settings['bifitkassa_fio'];
		/// адрес клиента в чеке (телефон или эл.почта)
		if ($address_type == 'phone' && $order->phone) {
			$address = self::__checkPhone($order->phone);
		} else {
			$address = self::__checkEmail($order->email);
		}
		// позиции оплаты заказа
		/// стоимость способа оплаты
		$o_payment = 0;
		/// стоимость упаковки
		$o_package = 0;
		/// стоимость доставки
		$o_shipping = $order->delivery_price;

		// параметры массива
		/// промежуточный итог
		$o_subtotal = 0;
		/// массив товаров для заполнения
		$r_products = array();
		/// массив товаров заказа
		$products = $this->orders->get_purchases(array(
			'order_id' => intval($order->id)
		));
		// перебираем массив товаров заказа
		foreach ($products as $key_id => $product) {
			/// корректируем цену товара с учётом НДС
			$prod_price = self::__formatprc($product->price);

			/// корректируем цену товара с учётом скидок
			$p_price = self::__formatprc(
				self::__checkProductPrice(
					$prod_price,
					$order->total_price,
					$order->discount,
					0
				)
			);
			/// формируем промежуточный итог
			$o_subtotal += $p_price * $product->amount;

			/// очищаем имя товара от спец-символов
			$p_name = preg_replace(
				'/[^\p{L}0-9 ]/iu',
				' ',
				html_entity_decode($product->product_name)
			);
			$p_name = preg_replace('/ +/', ' ', trim($p_name));

			/// формируем массив товаров для чека
			$r_products[$key_id] = new stdClass();
			$r_products[$key_id]->product_name = $p_name;
			$r_products[$key_id]->product_item_price = $p_price;
			$r_products[$key_id]->product_quantity = $product->amount;
			$r_products[$key_id]->product_tax = 0;
		}

		// сверка итоговых сумм заказа и чека
		$total_1 = self::__formatprc($o_subtotal + $o_package + $o_shipping);
		$total_2 = self::__formatprc($order->total_price);
		$diff =
			$total_1 > 0 && $total_2 > 0 && $total_1 != $total_2
				? abs($total_1 - $total_2)
				: 0;

		// параметры для чека
		$items = '';

		// формируем данные чека
		foreach ($r_products as $key_id => $product) {
			/// цена товара
			$p_price = $product->product_item_price;

			/// корректировка цены товара согласно сверки
			if ($diff > 0 && $p_price > $diff) {
				$p_price =
					$total_2 > $total_1
						? $p_price + $diff / $product->product_quantity
						: $p_price - $diff / $product->product_quantity;
				$diff = 0;
			}

			/// выводим данные товара в чек
			$items .= $items != '' ? ', ' : '';
			$items .= '{';
			$items .= '"calculationMethod":"' . $calc_method . '", ';
			$items .= '"paymentSubject":"PRODUCT", ';
			$items .= '"name":"' . $product->product_name . '", ';
			$items .= '"price":' . self::__formatprc($p_price) . ', ';
			$items .= '"quantity":' . $product->product_quantity . ', ';
			$items .=
				$vat_mode == 1
					? '"vat":"' . $vat . '", '
					: '"vat":"VAT_' . floor($product->product_tax) . '", ';
			$items .=
				'"total":' .
				self::__formatprc($p_price * $product->product_quantity);
			$items .= '}';
		}

		$pactax = 0;
		// упаковка
		if ($o_package > 0) {
			// выводим данные упаковки в чек
			$items .= $items != '' ? ', ' : '';
			$items .= '{';
			$items .= '"calculationMethod":"' . $calc_method . '", ';
			$items .= '"paymentSubject":"PRODUCT", ';
			$items .= '"name":"Упаковка", ';
			$items .= '"price":' . self::__formatprc($o_package) . ', ';
			$items .= '"quantity":1, ';
			$items .=
				$vat_mode == 1
					? '"vat":"' . $vat . '", '
					: '"vat":"VAT_' . floor($pactax) . '", ';
			$items .= '"total":' . self::__formatprc($o_package);
			$items .= '}';
		}

		// доставка
		if ($o_shipping > 0) {
			/// выводим данные способа доставки в чек
			$items .= $items != '' ? ', ' : '';
			$items .= '{';
			$items .= '"calculationMethod":"' . $calc_method . '", ';
			$items .= '"paymentSubject":"SERVICE", ';
			$items .= '"name":"Доставка", ';
			$items .= '"price":' . self::__formatprc($o_shipping) . ', ';
			$items .= '"quantity":1, ';
			$items .=
				$vat_mode == 1
					? '"vat":"' . $vat . '", '
					: '"vat":"VAT_' . floor($shptax) . '", ';
			$items .= '"total":' . self::__formatprc($o_shipping);
			$items .= '}';
		}

		// формируем чек
		$receipt = '{';
		$receipt .=
			'"type":"' .
			$receipt_type .
			'", "taxSystem":"' .
			$tax_system .
			'", ';
		$receipt .= '"cashier":{';
		$receipt .= '"name":"' . $cashier_name . '", ';
		$receipt .= '"inn":"' . self::__checkInn($cashier_inn, 1) . '"';
		$receipt .= '}, ';
		$receipt .= '"client":{';
		$receipt .= $fio ? '"name":"' . trim($order->name) . '", ' : '';
		$receipt .= '"address":"' . $address . '"';
		$receipt .= '}, ';
		$receipt .= '"paymentAddress":"' . $payment_address . '", ';
		$receipt .= '"items":[' . $items . '], ';
		$receipt .= '"total":' . self::__formatprc($order->total_price) . ', ';
		$receipt .=
			'"payments":{"' .
			$payment_type .
			'": ' .
			self::__formatprc($order->total_price) .
			'}';
		$receipt .= '}';

		// 3. ОТПРАВКА ЧЕКА В ФИСКАЛЬНЫЙ ПРОЦЕССИНГ
		//    передача контента чека в фискальный процессинг для дальнейшей фискализации

		// адрес для POST-запроса
		$url =
			'https://fp' .
			$test .
			'.bifit.com/processing-api/protected/documents/registration/receipts';

		// данные чека
		$data = $receipt;

		// ключ идемпотентности (Idempotency-Key)
		$o = [];
		$o['number'] = $order->id;
		$o['summ'] = self::__formatprc($order->total_price);
		$o['cms'] = 'Simpla';
		$idemp_key = self::__createGUID($o);

		// headers
		$headers = array(
			'Content-Type: application/json',
			'Authorization: Bearer ' . $bifit->access_token,
			'Idempotency-Key: ' . $idemp_key
		);

		// получаем идентификатор документа на процессинге (id)
		$receipt_id = json_decode(self::__loadData($url, $headers, $data));

		// 4. ПОЛУЧЕНИЕ ДОКУМЕНТА ПО ID
		//    получение документа с фискальными признаками по его номеру

		// параметры
		$doc = '';

		if (!is_object($receipt_id)) {
			// ссылка для GET-запроса
			$url =
				'https://fp' .
				$test .
				'.bifit.com/processing-api/protected/documents/' .
				$receipt_id;

			// headers
			$headers = array('Authorization: Bearer ' . $bifit->access_token);

			// получаем документ
			$doc = json_decode(self::__loadData($url, $headers, false, 'GET'));
		}

		// ССЫЛКА НА ЧЕК

		// формируем ссылку на чек
		$receipt_link = !is_object($receipt_id)
			? 'https://fp' .
				$test .
				'.bifit.com/processing-api/receipts/' .
				$idemp_key
			: 'XXX';

		// ИСТОРИЯ ОПЕРАЦИИ

		// параметры объекта
		$object = new stdClass();
		/// id заказа
		$object->order_id = $order->id;
		/// номер заказа
		$object->order_number = $order->id;
		/// дата заказа
		$object->order_date = $order->date;
		/// дата операции
		$object->action_date = date('Y-m-d H:i:s');
		/// ссылка на чек
		$object->receipt_link = $receipt_link;
		/// id полученного документа
		$object->receipt_id = !is_object($receipt_id) ? $receipt_id : '000';
		/// тип проводимого документа
		$object->receipt_type = $receipt_type;
		/// лог операции (будет заполнен далее)
		$object->log = '';
		// сохраняем операцию в историю
		self::__saveReport(
			$test,
			$bifit,
			$receipt,
			$receipt_id,
			$doc,
			$object,
			$idemp_key
		);
	}

	public function process($orderId)
	{
		$order = $this->orders->get_order(intval($orderId));
		$settings = (array) $this->bifitactions->getSettings();
		// параметры плагина
		/// выбранный режим работы
		$test = $settings['bifitkassa_test'] ? '-test' : '';
		/// токен для соединения
		$token =
			$test != ''
				? 'P5cKbUUD9uSSrSlGdzspLblvBnD0GzTAE0cLmAPSEMxJ79DtLE'
				: $settings['token'];

		$status_id = $order->status;
		$payment_id = $order->payment_method_id;
		$payed = (int) $order->paid;

		// перебираем вкладки типов документа
		for ($i = 1; $i <= 4; $i++) {
			/// узнаём нужно ли использовать данный тип документа
			$use_type = (int) $settings['bifitkassa_use_type_' . $i];
			/// если использовать нужно
			if ($use_type) {
				//// заказ оплачен
				$order_paid = (int) $settings['bifitkassa_order_paid_' . $i];
				//// статус заказа
				$pm_status = $settings['bifitkassa_pm_statuses_' . $i];
				//// способ оплаты
				$pm_ids = $settings['bifitkassa_pm_ids_' . $i];
				//// уже есть в БД
				$exist = $this->getReportId($orderId, $use_type);
				if ($exist) {
					//continue;
				}

				// Если заказ оплачен не совпадает
				if (
					isset($order_paid) &&
					$order_paid != '-1' &&
					$order_paid != $payed
				) {
					continue;
				}

				// Если статус не совпадает
				if (isset($pm_status) && $pm_status != $status_id) {
					continue;
				}

				// Если способы оплаты не совпадает
				if (!in_array($payment_id, $pm_ids)) {
					continue;
				}

				///// запускаем БИФИТ-процесс
				self::__mainProcess($settings, $order, $test, $token, $i);
			}
		}
	}

	/**
	 * @param $orderId
	 * @return mixed
	 */
	private function getPaymentId($orderId)
	{
		$sql =
			'SELECT o.payment_details FROM __orders AS o WHERE o.id=' .
			$this->db->escape((int) $orderId);
		$query = $this->db->placehold($sql);
		$this->db->query($query);

		return $this->db->result('payment_details');
	}

	/**
	 * @param $orderId
	 * @return mixed
	 */
	private function getReportId($orderId, $type)
	{
		$sql =
			'SELECT COUNT(id) as count FROM __bifit_reports  WHERE order_id=' .
			$this->db->escape((int) $orderId) .
			' AND receipt_id = ' .
			$this->db->escape((int) $type) .
			'';
		$query = $this->db->placehold($sql);
		$this->db->query($query);

		return (int) $this->db->result('count');
	}
}
